package org.eclipse.swt.tools.actionscript.ui;

import org.eclipse.swt.tools.actionscript.ActionScriptCorePlugin;
import org.eclipse.ui.console.ConsolePlugin;
import org.eclipse.ui.console.IConsole;
import org.eclipse.ui.console.IConsoleFactory;
import org.eclipse.ui.console.IConsoleManager;

public class ActionScriptBuildConsoleFactory implements IConsoleFactory {
    static ActionScriptBuildConsole console = null;
    
    public ActionScriptBuildConsoleFactory() {
	}
    
    public static synchronized ActionScriptBuildConsole getConsole () {
    	if (console == null) console = new ActionScriptBuildConsole();
    	return console;
    }
    
    /* (non-Javadoc)
     * @see org.eclipse.ui.console.IConsoleFactory#openConsole()
     */
    public void openConsole() {
    	IConsoleManager consoleManager = ConsolePlugin.getDefault().getConsoleManager();
    	ActionScriptBuildConsole console = getConsole();
    	ActionScriptCorePlugin.getDefault().getManager().setConsole(console);
        consoleManager.addConsoles(new IConsole[]{console});
        consoleManager.showConsoleView(console);
    }
    
    

}
