package org.eclipse.swt.tools.actionscript.ui;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.jobs.Job;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.tools.actionscript.build.ActionScriptParticipant;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;

public class BuildSWCAction implements IObjectActionDelegate {

	ISelection currentSelection;
	
	class SWCJob extends Job {
		IJavaProject project;
		public SWCJob(IJavaProject project) {
			super(Messages.BuildSWCAction_0);
			this.project = project;
		}
		protected IStatus run(final IProgressMonitor monitor) {
			try {
				ActionScriptParticipant participant = new ActionScriptParticipant();
				participant.buildSWC(project);
			} catch (CoreException e) {	
				e.printStackTrace();
			} finally {
				monitor.done();
			}
			return Status.OK_STATUS;
		}
	}
	
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
	}

	public void run(IAction action) {
		if (currentSelection instanceof IStructuredSelection) {
			Object selectedElement = ((IStructuredSelection) currentSelection).getFirstElement();
			if (selectedElement instanceof IJavaProject) {	
				SWCJob job = new SWCJob((IJavaProject) selectedElement);
				job.schedule();
			}
		}
	}

	public void selectionChanged(IAction action, ISelection selection) {
		this.currentSelection = selection;
	}

}
